<?php
if ( ! defined( 'ABSPATH' ) ) die( "Access denied" );

require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-ajax-save.php' );

//Utils
require_once ( CML_PLUGIN_ADMIN_PATH . 'fix.php' );
require_once ( CML_PLUGIN_ADMIN_PATH . 'migrate.php' );
require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-utils.php' );

//Help
require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-help.php' );

//Languages
require_once ( CML_PLUGIN_ADMIN_PATH . 'locales.php' );
require_once ( CML_PLUGIN_LAYOUTS_PATH . 'languages-item.php' );
require_once ( CML_PLUGIN_LAYOUTS_PATH . 'languages-downloader.php' );

//Extra media fields
//require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-media.php' );

//Wordpress wp-pointer
require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-wppointer.php' );

//CML notices
require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-notices.php' );

//Generate "settings.gen.php" and "cml_flags.css"
require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-settings-gen.php' );

/*
 * I have to load following php files here or quickedit will not works correctly
 */
require_once( CML_PLUGIN_ADMIN_PATH . 'admin-quickedit.php' );
require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-posts.php' );

//Setting mode: basic, intermediate, advanced
$GLOBALS[ 'cml_show_mode' ] = get_option( "ceceppaml_admin_advanced_mode", "show-basic" );

class CMLAdmin extends CeceppaML {
  public function __construct() {
    parent::__construct();

    global $_cml_settinsg, $pagenow;

    /*
     * Wizard?
     */
    if( get_option( "cml_show_wizard" ) || isset( $_GET[ 'cml-restore-wizard' ] ) ) {
      add_action( 'admin_notices', array( & $this, 'wizard' ) );
    }

    //Scan folders for wpml-config.xml?
    add_action( 'plugins_loaded', array( & $this, 'scan_plugin_folders' ), 10 );

    //When new plugin is activate I execute scan again :)
    add_action( 'activated_plugin', array( & $this, 'plugin_activated' ), 10 );

    /*
     * I need it to let user to see translated post also in admin panel,
     * but I use it only in edit.php page, or permalink change will cause 500 Error :(
     *
     * translate_home option can be used by external plugins to allow home url translation
    */
    $seo = CMLUtils::_get( '_seo' );
    if( is_array( $seo ) ) {
      foreach( $seo as $s ) {
        if( $s[ 'pagenow' ] == $pagenow ) {
          if( isset( $s[ 'page' ] ) && $s[ 'page' ] != $_GET[ 'page' ] ) {
            break;
          }

          CMLUtils::_set( "translate_home", 1 );
          CMLUtils::_set( '_real_language', CMLLanguage::get_default_id() );
        }
      }
    }

    if( in_array( $pagenow, array( "post.php", "post-new.php", "edit.php" ) )
        || CMLUtils::_get( "translate_home", 1 ) ) {
        if( ! ( isset( $_GET[ 'post_type' ] ) && 'page' == $_GET[ 'post_type' ] ) ) {
        /*
         * I need to force home url to post language or
         * wp show permalink in according to current language :O
         */
        if( isset( $_GET[ 'post' ] ) ) {
          $post = intval( $_GET[ 'post' ] );
          $lang = CMLLanguage::get_id_by_post_id( $post );
          $this->_force_category_lang = $lang;
        }

        add_filter( 'home_url', array( & $this, 'translate_home_url' ), 0, 4 );
      }
    }

    if( $pagenow == "widgets.php" ) {
      require_once CML_PLUGIN_INCLUDES_PATH . "shortcodes.php";
    }

    /*
     * update existsings post to default language?
     */
    if( isset( $_GET[ 'cml_update_existings_posts' ] ) ) {
     add_action( 'admin_footer', array( & $this, 'update_all_posts_language' ) );
    }

    /*
     * Scripts & Styles...
     */
    add_action( 'admin_enqueue_scripts', array( & $this, 'admin_scripts' ) );

    //Plugin menu
    add_action( 'admin_menu', array( & $this, 'add_menu_pages' ) );

    //Ajax
    add_action( 'wp_ajax_ceceppaml_advanced_mode', 'cml_admin_save_advanced_mode' );
    add_action( 'wp_ajax_ceceppaml_save_item', 'cml_admin_save_language_item' );  //Save single item
    
    //Options page
    add_action( 'wp_ajax_ceceppaml_save_options_actions', 'cml_admin_save_options_actions' );  
    add_action( 'wp_ajax_ceceppaml_save_options_filters', 'cml_admin_save_options_filters' );
    add_action( 'wp_ajax_ceceppaml_save_options_flags', 'cml_admin_save_options_flags' );
    add_action( 'wp_ajax_ceceppaml_save_site_title', 'cml_admin_save_site_title' );

    //generate mo file
    add_action( 'wp_ajax_ceceppaml_generate_mo', 'cml_admin_generate_mo' );

    //Widget page
    add_action( 'load-widgets.php', array( & $this, 'page_widgets' ), 10 );
    
    //Navigation menu
    add_action( 'load-nav-menus.php', array( & $this, 'page_menu' ), 10 );

    //Categories and tags
    add_action( 'admin_init', array ( & $this, 'setup_taxonomies_fields' ), 10 );

    //Grab theme language path
    add_filter( 'override_load_textdomain', array( &$this, 'grab_theme_locale' ), 0, 3 );

    //Add "shadow" div in the footer
    add_action( 'admin_footer', array( & $this, 'admin_footer' ) );
    
    //set wordpress locale
    add_filter( 'locale', array( & $this, 'setlocale' ), 0, 1 );
    
    //Contextual help
    add_filter( 'contextual_help', array( & $this, 'add_tips_to_help_tab' ), 10 );
  }

  function admin_scripts() {
    if( isset( $_GET[ 'page' ] ) && "ceceppaml-language-page" == $_GET[ 'page' ] ) {
      if( 0 == intval( @$_GET[ 'tab'] ) ) 
      wp_register_script( 'ceceppaml-admin-languages', CML_PLUGIN_JS_URL . 'admin.languages.js', array( 'ceceppaml-admin-script' ) );
    }

    wp_register_script( 'ceceppaml-admin-script', CML_PLUGIN_JS_URL . 'admin.js' );
    wp_register_script( 'ceceppaml-tipsy', CML_PLUGIN_JS_URL . 'jquery.tipsy.js' );
    wp_register_script( 'ceceppaml-transition', CML_PLUGIN_JS_URL . 'jquery.transit.min.js' );

    //Available languages, for search
    $languages = array();
    foreach( $GLOBALS[ 'cml_flags' ] as $lang ) {
      $languages[] = $lang;
    }

    $tags = get_tags();
    $names = array();
    foreach( $tags as $tag ) {
      $names[] = array( 
                      'id' => $tag->term_id,
                      'label' => $tag->name,
                      );
    }

    //For ajax 
    $secret = array( 
                    'secret' => wp_create_nonce( "ceceppaml-nonce" ),
                    'languages' => json_encode( $languages ),
                    'unloadmsg' => __( "The changes you made will be lost if you navigate away from this page.", 'ceceppaml' ),
                    'lessmsg' => __( "Less", "ceceppaml" ),
                    'moremsg' => __( "More", "ceceppaml" ),
                    'deletemsg' => __( "Delete", "ceceppaml" ),
                    'restoremsg' => __( "Restore", "ceceppaml" ),
                    'custommsg' => __( "Custom", "ceceppaml" ),
                    'dateformat' => get_option( 'date_format' ),
                    'tags' => json_encode( $names),
                    );
    wp_localize_script( 'ceceppaml-admin-script', 'ceceppaml_admin', $secret );

    //Styles
    wp_register_style( 'ceceppaml-tipsy-style', CML_PLUGIN_URL . 'css/tipsy.css' );
    wp_register_style( 'ceceppaml-admin-style', CML_PLUGIN_URL . 'css/admin.css' );
  }

  function add_menu_pages() {
    $page[] = add_menu_page('Ceceppa ML Options', __('Ceceppa Multilingua', 'ceceppaml'), 'administrator', 'ceceppaml-language-page', array(&$this, 'form_languages'), CML_PLUGIN_IMAGES_URL . 'logo-mini.png');

    $page[] = add_submenu_page( 'ceceppaml-language-page', '<div class="separator" /></div>', '<div class="cml-separator" />' . __( 'Translate', 'ceceppaml' ) . '</div>', 'administrator', '', null );

    $page[] = add_submenu_page('ceceppaml-language-page', __('My translations', 'ceceppaml'), __('My translations', 'ceceppaml'), 'manage_options', 'ceceppaml-translations-page', array(&$this, 'form_translations'));
    $page[] = add_submenu_page('ceceppaml-language-page', __('Widget titles', 'ceceppaml'), __('Widget titles', 'ceceppaml'), 'manage_options', 'ceceppaml-widgettitles-page', array(&$this, 'form_translations'));
    $page[] = add_submenu_page('ceceppaml-language-page', __('Site Title'), __( 'Site Title' ) . "/" . __( 'Tagline' ), 'manage_options', 'ceceppaml-translations-title', array(&$this, 'form_translations'));
    $page[] = add_submenu_page('ceceppaml-language-page', __('Plugin', 'ceceppaml'), __( 'Plugin', 'ceceppaml' ), 'manage_options', 'ceceppaml-language-page&tab=2', array(&$this, 'form_languages'));
    $page[] = add_submenu_page('ceceppaml-language-page', __('Theme', 'ceceppaml'), __( 'Theme', 'ceceppaml' ), 'manage_options', 'ceceppaml-translations-plugins-themes', array(&$this, 'form_translations'));

    $page[] = add_submenu_page( 'ceceppaml-language-page', '<div class="separator" /></div>', '<div class="cml-separator" />' . __( 'Flags', 'ceceppaml' ) . '</div>', 'administrator', '', null );

    $page[] = add_submenu_page('ceceppaml-language-page', __('Show flags', 'ceceppaml'), __('Show flags', 'ceceppaml'), 'manage_options', 'ceceppaml-flags-page', array( &$this, 'form_flags' ) );
    
    $page[] = add_submenu_page( 'ceceppaml-language-page', '<div class="separator" /></div>', '<div class="cml-separator" />' . __( 'Settings', 'ceceppaml' ) . '</div>', 'administrator', '', null );

    $page[] = add_submenu_page('ceceppaml-language-page', __('Settings', 'ceceppaml'), __('Settings', 'ceceppaml'), 'manage_options', 'ceceppaml-options-page', array(&$this, 'form_options'));

    //Addons
    $page[] = add_submenu_page( 'ceceppaml-language-page', '<div class="separator" /></div>', '<div class="cml-separator" />' . __( 'Addons', 'ceceppaml' ) . '</div>', 'administrator', '', null );

    $page[] = add_submenu_page('ceceppaml-language-page', __('Available addons', 'ceceppaml'), __('Available addons', 'ceceppaml'), 'manage_options', 'ceceppaml-addons-page', array( & $this, 'form_addons' ) );

    //filter all installe addons
    $addons = apply_filters( 'cml_addons', array() );
    $tab = 1;
    foreach( $addons as $addon ) {
      $page[] = add_submenu_page( 'ceceppaml-language-page', 
                                  $addon[ 'title' ], 
                                  $addon[ 'title' ], 'manage_options', 
                                  'ceceppaml-addons-page&tab=' . $tab, 
                                  array( & $this, 'form_addons' ) );

      $tab++;
    }

    //Documentation
    $page[] = add_submenu_page( 'ceceppaml-language-page', '<div class="separator" /></div>', '<div class="cml-separator" />' . __( 'Documentation', 'ceceppaml' ) . '</div>', 'administrator', '', null );
    $page[] = add_submenu_page( 'ceceppaml-language-page', __('Shortcodes', 'ceceppaml'), __('Shortcode', 'ceceppaml'), 'manage_options', 'ceceppaml-shortcode-page', array( & $this, 'shortcode_page' ) );
    $page[] = add_submenu_page( 'ceceppaml-language-page', __('Api', 'ceceppaml'), __('Api', 'ceceppaml'), 'manage_options', 'ceceppaml-api-page', array( & $this, 'api_page' ) );
    
    foreach( $page as $p ) :
      add_action( 'load-' . $p, array( &$this, 'add_pointers' ), 0 );           //Add wp-pointers
      add_action( 'admin-footer-' . $p, array( &$this, 'admin_footer' ) );
    endforeach;

    add_action( 'admin_print_styles', array( &$this, 'load_styles' ) );
    add_action( 'load-nav-menus.php', array( &$this, 'add_tips_to_help_tab' ) );
    add_action( 'load-options-reading.php', array( &$this, 'add_tips_to_help_tab' ) );
    add_action( 'load-options-general.php', array( &$this, 'add_tips_to_help_tab' ) );

    add_action( 'load-edit.php', array( &$this, 'add_pointers_to_post_list' ), 0 );           //Add wp-pointers
    add_action( 'load-post.php', array( &$this, 'add_pointers_to_post_meta_box' ), 0 );           //Add wp-pointers
    add_action( 'load-post-new.php', array( &$this, 'add_pointers_to_post_meta_box' ), 0 );           //Add wp-pointers

    add_action( 'load-nav-menus.php', array( &$this, 'add_pointers_to_menu_page' ), 0 );           //Add wp-pointers
  }
  
  function load_styles() {
    wp_enqueue_script( 'jquery-ui-autocomplete' );
    wp_enqueue_script( 'jquery-ui-draggable' );
    wp_enqueue_script( 'jquery-ui-sortable' );
    wp_enqueue_script( 'ceceppaml-transition' );
    wp_enqueue_script( 'ceceppaml-admin-script' );
    wp_enqueue_script( 'ceceppaml-tipsy' );
    
    wp_enqueue_style( 'ceceppaml-tipsy-style' );
    wp_enqueue_style( 'ceceppaml-admin-style' );
    
    //Wp-Pointer
    wp_enqueue_style( 'wp-pointer' );
    wp_enqueue_script( 'wp-pointer' );
  }

  /*
   * Manage language
   */
  function form_languages() {
    wp_enqueue_script( 'ceceppaml-admin-languages' );

    require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-languages.php' );
  }
  
  /*
   * Manage options
   */
  function form_options() {
    require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-options.php' );
  }

  /*
   * Flags options
   */
  function form_flags() {
    require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-flags.php' );
  }

  /*
   * Widget titles
   */
  function form_translations() {
    wp_enqueue_script( 'ceceppaml-admin-mytrans', CML_PLUGIN_JS_URL . 'admin.mytrans.js' );

    require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-translations.php' );
  }

  /*
   * Addons
   */
  function form_addons() {
    require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-addons.php' );
  }


  /*
   * Add "pointer" 
   */
  function add_pointers() {
    global $pagenow;
    
    if( isset( $_GET[ 'page' ] ) && "ceceppaml-options-page" == $_GET[ 'page' ] ) {
      $this->add_pointers_to_settings_page();

      return;
    }

    if( isset( $_GET[ 'page' ] ) && "ceceppaml-language-page" == $_GET[ 'page' ] ) {
      cml_add_pointer( "#contextual-help-link", __( 'Help', 'ceceppaml' ),
                      __( 'Click here to show the meaning of language fields', 'ceceppaml' ),
                      array( "edge" => "top", 'align' => 'right' ) );
    }

    //Add pointers
    $list = "<br /><dl class=\"cml-dl-list\">";
    $list .= sprintf( '<dt> %s</dt> <dd> %s</dd>', __( 'Basic', 'ceceppaml' ), __( 'You can order languages, set the default one, enable/disable them ', 'ceceppaml' ) );
    $list .= sprintf( '<dt> %s</dt> <dd> %s</dd>', __( 'Intermediate', 'ceceppaml' ), __( 'You can also edit language name and date format', 'ceceppaml' ) );
    $list .= sprintf( '<dt> %s</dt> <dd> %s</dd>', __( 'Advanced', 'ceceppaml' ), __( 'You can change flag and edit all language fields', 'ceceppaml' ) );
    $list .= "</ul>";
    
    $title = __( 'Choose settings level', 'ceceppaml' );
    cml_add_pointer( ".hndle .cml-box-mode > ul", __( 'Settings', 'ceceppaml' ), $title . $list, array( "edge" => "top", 'align' => 'left' ) );

    //Available languages
    $list = __( 'This is the list of your languages.', 'ceceppaml' ) . "<br />";
    $list .= __( 'Drag items for change its order.', 'ceceppaml' ) . "<br />";
    $list .= '<dl class="cml-dl-list">';
    $list .= '<dt>' . __( 'Flag', 'ceceppaml' ) . '</dt>';
    $list .= '<dd>' . __( 'Click on flag for change or customize', 'ceceppaml' ) . "</dd>";

    $list .= '<dt><img src="' . CML_PLUGIN_IMAGES_URL . 'heart.png" /></dt>';
    $list .= '<dd>' . __( 'Click on heart for set default language', 'ceceppaml' ) . "</dd>";

    $list .= '<dt>&#10004;</dt>';
    $list .= '<dd>' . __( "Click on &#10004; for set enable/disable language", 'ceceppaml' ) . "</dd>";
    
    cml_add_pointer( "#cml-box-languages", __( 'Your languages', 'ceceppaml' ), $list, array( "edge" => "top", 'align' => 'left' ) );

    //Available languages
    cml_add_pointer( "#cml-box-available-languages", __( 'Add language', 'ceceppaml' ), __( 'List of all available languages.<br /> Click on item to choose flag and add it to your languages', 'ceceppaml' ), array( "edge" => "bottom", 'align' => 'left' ) );
    
    //Search language
    cml_add_pointer( ".cml-box-right #search", __( 'Search language', 'ceceppaml' ), __( 'Search the language from the availables and click for add it', 'ceceppaml' ), array( "edge" => "bottom", 'align' => 'left' ) );

    //Add custom language
    cml_add_pointer( ".cml-box-right input[name=\"add-custom\"]", __( 'Add custom language', 'ceceppaml' ), __( 'Click here for add custom language', 'ceceppaml' ), array( "edge" => "bottom", 'align' => 'left' ) );
    
    //Save languages
    cml_add_pointer( ".cml-box-right input[name=\"save-all\"]", __( 'Save languages', 'ceceppaml' ), __( 'Click here for save changes', 'ceceppaml' ), array( "edge" => "left", 'align' => 'middle' ) );
    
    //Theme main language
    cml_add_pointer( ".ceceppa-form-translations.theme > .cml-tablenav #cml-lang", __( 'Theme language', 'ceceppaml' ), __( 'Choose in which languages translate:', 'ceceppaml' ), array( "edge" => "right", 'align' => 'middle' ) );
  }
  
  function add_pointers_to_settings_page() {
    //Help
    cml_add_pointer( ".cml-first-help-wp", __( 'Help', 'ceceppaml' ), __( 'Click here for show/hide help', 'ceceppaml' ), array( "edge" => "right", 'align' => 'middle' ) );
  }

  function add_pointers_to_post_list() {
    //All posts/page filter by language
    cml_add_pointer( ".cml-lang-sel", __( 'Filter list', 'ceceppaml' ), __( 'Filter list by language', 'ceceppaml' ), array( "edge" => "left", 'align' => 'middle' ) );
    cml_add_pointer( "thead th.column-cml_flags", __( 'Filter list', 'ceceppaml' ), __( 'Click here to filter list by language', 'ceceppaml' ), array( "edge" => "left", 'align' => 'middle' ) );
    cml_add_pointer( "thead .cml-filter-current", __( 'Active language', 'ceceppaml' ), __( 'This is the style of current language', 'ceceppaml' ), array( "edge" => "left", 'align' => 'middle' ) );
  }

  //Post data "box"
  function add_pointers_to_post_meta_box() {
    $msg = __( 'Choose the language of current post/page.', 'ceceppaml' ) . "<br />";
    $msg .= "<br /><strong>" . __( 'All languages', 'ceceppaml' ) . "</strong>&nbsp;";
    $msg .= __( 'means that post/page will available in all languages', 'ceceppaml' );
    $msg .= "<br />";
    cml_add_pointer( "#ceceppaml-meta-box #cml-lang", __( 'Post/Page language', 'ceceppaml' ), $msg, array( "edge" => "right", 'align' => 'middle' ) );

    //choose
    $msg = __( 'Assign translations', 'ceceppaml' ) . "<br /><br />";
    $msg .= "<strong>" . __( "Assign the same post to multiple languages.", "ceceppaml" ) . "</strong><br />";
    $msg .= __( "If you need you can assign post to multiple language", "ceceppaml" ) . ".<br />";
    $msg .= "<i>" . __( "In this case you can't choose the option \"All languages\" from \"Language\" combo, so you have to choose one of it existing languages, isn't important which one.", "ceceppaml" );
    cml_add_pointer( "#ceceppaml-meta-box .cml-post-translations", __( 'Translations', 'ceceppaml' ), $msg, array( "edge" => "right", 'align' => 'middle' ) );

    //add/edit
    cml_add_pointer( ".cml-post-translations > li:first-child .cml-button-edit", __( 'Translations', 'ceceppaml' ), __( 'Click here Add/Edit translation', 'ceceppaml' ), array( "edge" => "right", 'align' => 'middle' ) );
    
    //add/edit
    $text = __( 'Permalink will modified in according to current "Url modification mode" setting.', 'ceceppaml' ) . "<br />";
    $text .= __( "When two post/page has same title Wordpress automatically append a number -## to permalink, don't worry the plugin will remove it in fronted.", 'ceceppaml' );
    cml_add_pointer( "#sample-permalink #editable-post-name", __( 'Permalink', 'ceceppaml' ), $text, array( "edge" => "left", 'align' => 'middle' ) );
  }
  
  function add_pointers_to_menu_page() {
    $msg = __( 'For each languages you can customize "Navigation label" or url, but you have to save menu first', 'ceceppaml' );

    cml_add_pointer( "#nav-menu-header .publishing-action #save_menu_header",
                    __( 'Customize labels', 'ceceppaml' ),
                    $msg,
                    array( "edge" => "right", 'align' => 'middle' ) );

    cml_add_pointer( 'form[name="cml-menu-primary-name"] select',
                    __( 'Set menu to switch', 'ceceppaml' ),
                    __( 'Your theme support multiple menus, if you need to use different menu for each language you have to choose witch one switch', 'ceceppaml' ),
                    array( "edge" => "top", 'align' => 'left' ) );

  }

  function add_tips_to_help_tab() {
    cml_admin_add_help_tab();
  }

  //Widget visibility
  function page_widgets() {
    require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-widgets.php' );
  }

  //Menu metabox
  function page_menu() {
    require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-menu.php' );
  }

  function admin_footer() {
    echo '<div class="cml-box-shadow"></div>';
  }

  function grab_theme_locale( $false, $domain, $mofile ) {
    global $pagenow;
  
    //Recupero il nome del tema corrente
    $theme = wp_get_theme();
  
    $path = get_template_directory();	//Path del tema
    $info = pathinfo( $mofile );
  
    if( strcasecmp( $info[ 'dirname' ], $path ) > 0 ) {
      $GLOBALS[ '_cml_theme_locale_path' ] = $info[ 'dirname' ];
  
      //Nome del tema e path "locale"
      update_option( 'cml_current_theme', $theme->Name );
      update_option( 'cml_current_theme_locale', $info[ 'dirname' ] );
  
      //Fatto
      //remove_filter( 'load_textdomain_mofile', array( &$this, 'grab_theme_locale' ), 0, 2 );
    }

    return false;
  }
  
  function setup_taxonomies_fields() {
    global $pagenow;
    
    if( $pagenow != "nav-menus.php" ) {
  
      $taxonomies = get_taxonomies();
    
      foreach( $taxonomies as $taxonomy ) {
        add_action( "${taxonomy}_edit_form_fields", 'cml_admin_taxonomy_edit_form_fields', 10, 1 ); 
        add_action( "${taxonomy}_add_form_fields", 'cml_admin_taxonomy_add_form_fields', 10, 1 );
        add_action( "edited_{$taxonomy}", array( & $this, 'save_taxonomies_extra_fields' ), 10, 1 );
        add_action( "created_{$taxonomy}", array( & $this, 'save_taxonomies_extra_fields' ), 10, 1 );
        add_action( "delete_{$taxonomy}", array( & $this, 'delete_taxonomies_extra_fields' ), 10, 1 );
      }
    
      add_action( 'load-edit-tags.php', array( & $this, 'taxonomies_extra_fields' ) , 10 );
    }

    //Translate term
    add_filter( 'get_term', array( & $this, 'translate_term' ), 0, 2 );
    add_filter( 'get_terms', array( & $this, 'translate_terms' ), 0, 3 );
    add_filter( 'get_the_terms', array( & $this, 'translate_terms' ), 0, 3 );
  }

  function translate_term( $term, $taxonomy ) {
    global $pagenow;

    if( ! is_object( $term ) ) {
      return $term;
    }
    
    if( in_array( $pagenow, array( "edit.php", "post.php", "nav-menus.php" ) )        
        || CMLLanguage::is_default() ) {
      return $term;
    }


    if( in_array( $pagenow, array( "edit.php", "post.php", "edit-tags.php" ) ) ) {
      $lang = CMLPost::get_language_id_by_id( get_the_ID() );
    } else {
      $lang = CMLLanguage::get_current_id();
    }

    $term->name = CMLTranslations::get( $lang,
                                       $term->name, "C", false, true );
    
    return $term;
  }

  function translate_terms( $terms, $post_id, $taxonomy ) {
    global $pagenow;

    if( in_array( $pagenow, array( "edit.php", "post.php", "nav-menus.php" ) )        
        || CMLLanguage::is_default() ) {
      return $terms;
    }

    $t = array();
    foreach( $terms as $term ) {
      $t[] = $this->translate_term( $term, null );
    }

    return $t;
  }

  function taxonomies_extra_fields() {
    wp_enqueue_script( 'ceceppaml-admin-taxonomies', CML_PLUGIN_JS_URL . 'admin.taxonomies.js' );

    require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-taxonomies.php' );
  }
  
  function save_taxonomies_extra_fields( $term_id ) {
    require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-taxonomies.php' );

    cml_admin_save_extra_taxonomy_fileds( $term_id );
  }
  
  function delete_taxonomies_extra_fields( $term_id ) {
    require_once ( CML_PLUGIN_ADMIN_PATH . 'admin-taxonomies.php' );

    cml_admin_delete_extra_taxonomy_fields( $term_id );
  }
  
  function shortcode_page() {
    require_once( CML_PLUGIN_DOC_PATH . "shortcodes.php" );
  }

  function api_page() {
    require_once( CML_PLUGIN_DOC_PATH . "api.php" );
  }

  function setlocale( $locale ) {
    global $pagenow;

    if( $pagenow == "wp-login.php" ) return $locale;

    $lang = CMLLanguage::get_default();
    if( empty( $lang ) ) return $locale;
    
    $slug = $lang->cml_language_slug;

    $logged_in = function_exists( 'is_user_logged_in' ) && is_user_logged_in();
    if( is_admin() && $logged_in ) {
      global $current_user;

      get_currentuserinfo();

      $user = $current_user->user_login;
      $slug = get_option( "cml_${user}_locale", CMLLanguage::get_default()->cml_language_slug );
    }

    $slug = isset( $_GET[ 'lang' ] ) ? esc_attr( $_GET[ 'lang' ] ) : $slug;

    //get language by slug
    $lang = CMLLanguage::get_by_slug( $slug );
    
    CMLLanguage::set_current( $lang );
    CMLUtils::_set( '_real_language', $lang->id );

    //Set current user language;
    if( isset( $user ) ) {
      update_option( "cml_${user}_locale", $lang->cml_language_slug );
    }

    return $lang->cml_locale;
  }
  
  function wizard() {
    if( isset( $_GET[ 'wdone' ] ) ) {
      update_option( "cml_show_wizard", false );
      delete_option( "_cml_update_existings_posts" );

      return;
    }

    require_once ( CML_PLUGIN_ADMIN_PATH . 'wizard.php' );
  }
  
  function no_tables_found() {
    $error = __( "No tables found, Ceceppa Multilingua can't works correctly.", "ceceppaml" ) . "<br />";
    $error .= __( "Disable and enable again the plugin for rebuild tables.", "ceceppaml" );
echo <<< EOT
    <div class="updated">
      <p>
        $error
      </p>
    </div>
EOT;
  }
  
  /*
   * update language of existings posts
   */
  function update_all_posts_language() {
    cml_update_all_posts_language();

    cml_fix_rebuild_posts_info();
  }
  
  /*
   * add language info on items in "nav-menu.php" page :)
   */
  function translate_menu_item( $item ) {
    global $pagenow;

    if( $pagenow != "nav-menus.php" ) {
      return $item;
    }

    switch($item->object) {
    case 'page':
    case 'post':
      $lang = CMLLanguage::get_by_post_id( $item->ID );

      $item->post_title .= " (" . CMLLanguage::get_slug( $lang ) . ")";
      break;
    default:
      return $item;
    } //endswitch;

    return $item;
  }
  
  /*
   * scan plugins folders
   */
  function plugin_activated() {
    delete_option( '_cml_wpml_config' );

    update_option( '_cml_scan_folders', 1 );
  }

  function scan_plugin_folders() {
    if( 1 == get_option( '_cml_scan_folders' ) ) {
      cml_admin_scan_plugins_folders();
    }
  }
}
?>